package test;

import java.io.Serializable;
import java.util.Collection;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.annotation.Resource;
import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.ejb.Singleton;
import javax.ejb.Schedule;
import javax.ejb.Startup;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;

@Stateless
public class MyTimerBean {

    private static final Logger LOG = Logger.getLogger(MyTimerBean.class.getName());
	private static volatile long counter1 = 0;

    @SuppressWarnings("unused")
	@TransactionAttribute(TransactionAttributeType.NOT_SUPPORTED)
	@Schedule(second="*", minute="*", hour="*", dayOfMonth="*", month="*", year="*", persistent=false)
    private void timerTriggered1() {
            LOG.warning("Count1 " + counter1++);
    }

	private static volatile long counter2 = 0;

    @SuppressWarnings("unused")
	@Schedule(second="*", minute="*", hour="*", dayOfMonth="*", month="*", year="*", persistent=false)
    private void timerTriggered2() {
            LOG.warning("Count2 " + counter2++);
    }

	private static volatile long counter3 = 0;

    @SuppressWarnings("unused")
	@TransactionAttribute(TransactionAttributeType.REQUIRES_NEW)
	@Schedule(second="*", minute="*", hour="*", dayOfMonth="*", month="*", year="*", persistent=false)
    private void timerTriggered3() {
            LOG.warning("Count3 " + counter3++);
    }

	private static volatile long counter4 = 0;

    @SuppressWarnings("unused")
	@TransactionAttribute(TransactionAttributeType.NOT_SUPPORTED)
	@Schedule(second="*", minute="*", hour="*", dayOfMonth="*", month="*", year="*", persistent=true)
    private void timerTriggered4() {
            LOG.warning("Count4 " + counter4++);
    }

	private static volatile long counter5 = 0;

    @SuppressWarnings("unused")
	@Schedule(second="*", minute="*", hour="*", dayOfMonth="*", month="*", year="*", persistent=true)
    private void timerTriggered5() {
            LOG.warning("Count5 " + counter5++);
    }
	
	private static volatile long counter6 = 0;

    @SuppressWarnings("unused")
	@TransactionAttribute(TransactionAttributeType.REQUIRES_NEW)
	@Schedule(second="*", minute="*", hour="*", dayOfMonth="*", month="*", year="*", persistent=true)
    private void timerTriggered6() {
            LOG.warning("Count6 " + counter6++);
    }
	
	@PostConstruct
    private void postConstruct() {
            LOG.warning("PostConstruct; count1: " + counter1 + "; count2: " + counter2 + "; count3: " + counter3 + "; count4: " + counter4 + "; count5: " + counter5 + "; count6: " + counter6);
    }

	@PreDestroy
    private void preDestroy() {
            LOG.warning("PreDestroy; count1: " + counter1 + "; count2: " + counter2 + "; count3: " + counter3 + "; count4: " + counter4 + "; count5: " + counter5 + "; count6: " + counter6);
    }


}
